#include "extdll.h"
#include "util.h"
#include "cbase.h"
#include "saverestore.h"
#include "player.h"
#include "client.h"
#include "spectator.h"
#include "client.h"
#include "soundent.h"
#include "decals.h"
#include "gamerules.h"
#include "game.h"
#include "items.h"

class CBot : public CBasePlayer //Derive a bot class from CBasePlayer and do nothing but set isnetclient to false.
{
public:
	virtual BOOL IsNetClient( void ) { return FALSE; }		// Bots should return FALSE for this, they can't receive NET messages
};

void CBaseMonster::BThink () {
	//Insert code here to change the values with which pfnRunPlayer move is called, thus causing the bot to act in various ways.

	g_engfuncs.pfnRunPlayerMove(edict(), pev->v_angle, 0, 0, 0, pev->button, 0, 50);
//	g_engfuncs.pfnRunPlayerMove(<bot edict>, <bot's view angles>, <forward move value>, <side move value> (strafing), <upward move value> (seems to do nothing), <buttons> (IN_ATTACK, etc.), <impulse number>, <msec value>);
}

void BotClientPutInServer( edict_t *pEntity )
{
	CBot *pPlayer;

	entvars_t *pev = &pEntity->v;

	pPlayer = GetClassPtr((CBot *)pev); //Link bot object to the edict

	pPlayer->Spawn() ;

	//Set the bots user info:
	g_engfuncs.pfnSetClientKeyValue(pPlayer->entindex(), g_engfuncs.pfnGetInfoKeyBuffer(pEntity), "name", "Bot");
	g_engfuncs.pfnSetClientKeyValue(pPlayer->entindex(), g_engfuncs.pfnGetInfoKeyBuffer(pEntity), "model", "gordon");
	g_engfuncs.pfnSetClientKeyValue(pPlayer->entindex(), g_engfuncs.pfnGetInfoKeyBuffer(pEntity), "topcolor", "150");
	g_engfuncs.pfnSetClientKeyValue(pPlayer->entindex(), g_engfuncs.pfnGetInfoKeyBuffer(pEntity), "bottomcolor", "150");

	pPlayer->isabot = 1;

	g_pGameRules->PlayerThink (pPlayer);
}


char *NameBot() { //Edit this function to come up with a name for your bot.
	return "Bot";
}

void BotConnect( edict_t *aEntity)
{
	edict_t *pEntity;
	char *botname;

	botname = NameBot();

	pEntity = g_engfuncs.pfnCreateFakeClient(botname);

	if (!pEntity) {
		ClientPrint(&aEntity->v, HUD_PRINTNOTIFY, UTIL_VarArgs( "Could not find any free client slots. Try setting maxplayers to a higher value.\n"));
		return;
	} //This means a fake client slot couldn't be created for some reason, so cancel the function.

	pEntity->v.netname = MAKE_STRING(botname); //Set the net name to the name we're using.

	BotClientPutInServer(pEntity);
}